package exam;

import java.util.*;
import java.io.*;

public class ExamAverage {
    
    private List<Student> students = new ArrayList<Student>();
   
    public ExamAverage() {
    }

    public ExamAverage(ArrayList<Student> sl) {
        students = new ArrayList<Student>(sl);
    }

    public List<Student> getStudents() {
        return students;
    }

    public String toString() {
        String str = "";
        for (Student s : students) {
            str  += s.toString() + String.format("%n");
        }
        return str;
    }

    public void addStudent(Student s) {
        students.add(s);
    }
    
    /**
     *   A megadott fajlbol beolvassa a hallgatok adatait, amelyek a
     *   kovetkezo formatumban vannak soronkent (ez elvalaszto jel
     *   elott es utan akarmennyi szokoz lehet): 
     *   Vezeteknev Keresztnev  | etrkod | jegy |
     *   @param fileName a bemeneti adatokat tartalmazó fajl neve
     */
    public void beolvas(String fileName) {  
		try(Scanner sc = new Scanner(new FileReader(fileName));){
			sc.useDelimiter("\\s*\\|\\s*");
			while(sc.hasNext()){
				String nev = sc.next();
				String etr = sc.next();
				int jegy = sc.nextInt();
				students.add(new Student(nev,etr,jegy));
			}
		}catch (FileNotFoundException e){
			System.err.println("File not found..");
		}catch (Exception e){
			System.err.println("Egyeb IO hiba");
		}
	}

    /**
     * @return a hallgatok jegyeinek atlaga
     */
    public double getAverage() {
        int osszeg = 0;
		for (Student st : students){
			osszeg += st.getMark();
		}
		return osszeg / students.size();
    }

    /**
     * A megadott fajlba kiirja az atlagot ket tizedesjegy
     * pontossaggal.
     * @param fileName a kimeneti falj neve
     */
    public void printout(String fileName) {
		try(PrintWriter pw = new PrintWriter(new FileWriter(fileName));)
		{
			pw.format("%.2f", getAverage());
		} catch (IOException e){
			System.err.println("IO exception");
		}
	
    }

}
